package com.szyd.setting;


import android.os.Bundle;
import android.os.Environment;
import android.support.annotation.NonNull;
import android.support.annotation.Nullable;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.TextView;

import com.szyd.uhfdemo.BuildConfig;
import com.szyd.uhfdemo.MyApp;
import com.szyd.uhfdemo.R;
import com.szyd.util.MUtil;
import com.szyd.util.ThreadUtil;

public class AboutHelpFragment extends Fragment {

    private String sdcardpath = Environment.getExternalStorageDirectory().getAbsolutePath() + "/UM7V1.2.4.bin";

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        return inflater.inflate(R.layout.fragment_about_help, container, false);
    }

    @Override
    public void onViewCreated(@NonNull View v, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(v, savedInstanceState);
        TextView sw_ver = v.findViewById(R.id.sw_ver);
        TextView hw_ver = v.findViewById(R.id.hw_ver);
        TextView fm_ver = v.findViewById(R.id.fm_ver);
        Button fm_update = v.findViewById(R.id.fm_update);

        sw_ver.append(BuildConfig.VERSION_NAME);
        hw_ver.append(getHardware());
        fm_ver.append(getFirmware());
        fm_update.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                MUtil.showProgressDialog("Updating firmware,please hold on...", getActivity());
                ThreadUtil.getInstance().getExService().execute(new Runnable() {
                    @Override
                    public void run() {
                        final boolean value = MyApp.getMyApp().getIdataLib().updateFirmware(sdcardpath, "UM7V1.2.4.bin");
                        getActivity().runOnUiThread(new Runnable() {
                            @Override
                            public void run() {
                                MUtil.cancleDialog();
                                MUtil.show(value ? "Firmware update succeeded." : "Sorry,firmware update failed.");
                            }
                        });
                    }
                });
            }
        });
    }

    // To get the firmware version
    private String getFirmware() {
        StringBuilder fw = new StringBuilder(MyApp.getMyApp().getIdataLib().firmwareVerGet());
        fw.insert(2, ".").insert(5, ".");
        return fw.toString();
    }

    //To get the hardware version
    private String getHardware() {
        StringBuilder hw = new StringBuilder(MyApp.getMyApp().getIdataLib().hardwareVerGet());
        hw.insert(2, ".").insert(5, ".");
        return hw.toString();
    }


}
