package com.szyd.setting;

import android.os.Bundle;
import android.support.annotation.NonNull;
import android.support.annotation.Nullable;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.EditText;
import android.widget.Spinner;

import com.szyd.uhfdemo.MyApp;
import com.szyd.uhfdemo.R;
import com.szyd.util.MUtil;

import static android.text.TextUtils.isEmpty;

public class LockTagFragment extends Fragment implements View.OnClickListener {

    private Spinner spFilterMbLock;
    private EditText EtFilterAdsLock, EtFilterLenLock, EtFilterDataLock;

    private Spinner spLock;
    private EditText EtAcPwdLock;

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        return inflater.inflate(R.layout.fragment_lock_tag, container, false);
    }

    @Override
    public void onViewCreated(@NonNull View v, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(v, savedInstanceState);
        View top = v.findViewById(R.id.lockTop);

        spLock = v.findViewById(R.id.sp_Lock);
        spFilterMbLock = top.findViewById(R.id.spinner_MB);

        EtFilterAdsLock = top.findViewById(R.id.Et_set_ads);
        EtFilterLenLock = top.findViewById(R.id.Et_Set_len);
        EtFilterDataLock = top.findViewById(R.id.Et_Set_data);

        EtAcPwdLock = v.findViewById(R.id.Et_AcPwdLock);
        v.findViewById(R.id.Bt_Lock).setOnClickListener(this);
        v.findViewById(R.id.Bt_unLock).setOnClickListener(this);

        EtAcPwdLock.setText("00000000");
        EtFilterAdsLock.setText("32");
        EtFilterLenLock.setText("96");
        EtFilterDataLock.setText("1234567890ABCDEF12345678");
    }

    @Override
    public void onClick(View v) {
        switch (v.getId()) {
            case R.id.Bt_Lock:
                lock(true);  //lock tag
                break;
            case R.id.Bt_unLock:
                lock(false); //unlock tag
                break;
        }
    }


    private void lock(boolean flag) {
        if (ifNotNull()) {
            int ads = Integer.valueOf(EtFilterAdsLock.getText().toString());
            int len = Integer.valueOf(EtFilterLenLock.getText().toString());
            int lockitem = spLock.getSelectedItemPosition() + 1;
            int val = spFilterMbLock.getSelectedItemPosition();
            boolean status = false;
            if (flag) {
                status = MyApp.getMyApp().getIdataLib().lockMen(EtAcPwdLock.getText().toString(), MyApp.UHF[val],
                        ads, len, EtFilterDataLock.getText().toString(), lockitem); //lock tag 
            } else {
                status = MyApp.getMyApp().getIdataLib().unlockMen(EtAcPwdLock.getText().toString(), MyApp.UHF[val],
                        ads, len, EtFilterDataLock.getText().toString(), lockitem); //unlock tag 
            }
            String str = status ? (flag ? "Locked successfully" : "Unlocked successfully") : (flag ? "Lock faied" : "Unlock failed");
            MUtil.show(str);
        } else {
            MUtil.show(R.string.data_notnull);
        }

    }

    private boolean ifNotNull() {
        return !isEmpty(EtFilterAdsLock.getText()) && !isEmpty(EtFilterLenLock.getText())
                && !isEmpty(EtFilterDataLock.getText()) && !isEmpty(EtAcPwdLock.getText());
    }

}
