package com.szyd.uhfdemo;


import android.annotation.SuppressLint;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.ProgressBar;
import android.widget.Spinner;
import android.widget.TextView;

import com.szyd.event.BackResult;
import com.szyd.event.GetRFIDThread;
import com.szyd.util.MUtil;

import static android.text.TextUtils.isEmpty;

public class SearchFragment extends Fragment implements View.OnClickListener, BackResult {

    private EditText etSetAds, etSetLen, etSetData;
    private CheckBox cBSetFilterSave;
    private Spinner spSetFilterMb;
    private Button Bt_SetFilter, Bt_Clear;

    private TextView currentTag;
    private ProgressBar singnalStrength;
    private Button searchFilterTag;

    private String content;

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        View v = inflater.inflate(R.layout.fragment_search, container, false);

        spSetFilterMb = v.findViewById(R.id.spinner_MB);
        etSetAds = v.findViewById(R.id.Et_set_ads);
        etSetLen = v.findViewById(R.id.Et_Set_len);
        etSetData = v.findViewById(R.id.Et_Set_data);
        cBSetFilterSave = v.findViewById(R.id.CB_Save);


        Bt_SetFilter = v.findViewById(R.id.Bt_SetFilter);
        Bt_Clear = v.findViewById(R.id.Bt_Clear);
        Bt_SetFilter.setOnClickListener(this);
        Bt_Clear.setOnClickListener(this);

        etSetAds.setText("32"); //EPC start address by default
        etSetLen.setText("96");//EPC end address by default
        etSetData.setText("1234567890ABCDEF12345678"); //EPC by default

        currentTag = v.findViewById(R.id.currentTag);
        singnalStrength = v.findViewById(R.id.singnalStrength);
        searchFilterTag = v.findViewById(R.id.searchFilterTag);
        searchFilterTag.setOnClickListener(this);

        content = getText(R.string.current_Tag).toString();
        return v;
    }

    @Override
    public void onResume() {
        super.onResume();
        GetRFIDThread.getInstance().setBackResult(this);
        GetRFIDThread.getInstance().setSearchTag(true);
    }

    @Override
    public void onPause() {
        super.onPause();
        GetRFIDThread.getInstance().setSearchTag(false);
    }

    @Override
    public void onClick(View v) {
        switch (v.getId()) {
            case R.id.Bt_SetFilter:
                filter();
                break;
            case R.id.Bt_Clear:
                clearFilter();
                break;
            case R.id.searchFilterTag:
                startOrStopRFID();
                break;
        }
    }

    private void filter() {
        if (ifNotNull()) {
            int ads = Integer.valueOf(etSetAds.getText().toString());
            int len = Integer.valueOf(etSetLen.getText().toString());
            int val = spSetFilterMb.getSelectedItemPosition();
            boolean status = MyApp.getMyApp().getIdataLib().filterSet
                    (MyApp.UHF[val], ads, len, etSetData.getText().toString(), cBSetFilterSave.isChecked());
            if (status) {
                //Set frequency to 915MHz, power to 25dBm
                MyApp.getMyApp().getIdataLib().powerSet(25);
                MyApp.getMyApp().getIdataLib().frequencyModeSet(3);
                MUtil.show("Filter succeeded");
            } else {
                MUtil.show("Filter failed");
            }
        } else {
            MUtil.show(R.string.data_notnull);
        }

    }

    private void clearFilter() {
        int val = spSetFilterMb.getSelectedItemPosition();
        boolean status = MyApp.getMyApp().getIdataLib().filterSet
                (MyApp.UHF[val], 0, 0, etSetData.getText().toString(), cBSetFilterSave.isChecked());
        if (status) {
            MUtil.show("Clear succeeded");
            //Reset the power as 30dbm,area frequency as US.
            MyApp.getMyApp().getIdataLib().powerSet(30);
            MyApp.getMyApp().getIdataLib().frequencyModeSet(4);
        } else {
            MUtil.show("Clear failed");
        }
    }

    private boolean ifNotNull() {
        return !isEmpty(etSetAds.getText()) && !isEmpty(etSetLen.getText()) && !isEmpty(etSetData.getText());
    }

    //Start or Stop Inventory
    public void startOrStopRFID() {
        boolean flag = !GetRFIDThread.getInstance().isIfPostMsg();
        if (flag) {
            MyApp.getMyApp().getIdataLib().startInventoryTag();
            Bt_SetFilter.setEnabled(false);
            Bt_Clear.setEnabled(false);
        } else {
            Bt_SetFilter.setEnabled(true);
            Bt_Clear.setEnabled(true);
            MyApp.getMyApp().getIdataLib().stopInventory();
        }
        GetRFIDThread.getInstance().setIfPostMsg(flag);
        searchFilterTag.setText(flag ? R.string.stop_rfid : R.string.read_rfid);
    }

    @Override
    public void onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_F8) //pistol trigger,defacult key value as 138
            startOrStopRFID();
    }

    private short maxValue = -29, minValue = -70; //The maximum and minimum value of RSSI

    @Override
    public void postResult(String[] tagData) {
        if (tagData != null) {
            String epc = tagData[1];
            final String rssiStr = tagData[2]; //Get tag RSSI

            int floatBit = Integer.parseInt(rssiStr.substring(rssiStr.length() - 1, rssiStr.length()));
            int intgerBit = Integer.parseInt(rssiStr.substring(0, rssiStr.length() - 2)); // Integer value
            if (floatBit > 5) {
                --intgerBit;
            } else {
                ++intgerBit;
            }
            int rssi = intgerBit;
            // int length = maxValue - minValue; 
            if (rssi >= maxValue) {
                rssi = maxValue;
            } else if (rssi <= minValue) {
                rssi = minValue;
            }
            rssi -= (minValue - 1);
            final int finalRssi = rssi;

            final String epcStr = content + epc;
            getActivity().runOnUiThread(new Runnable() {
                @SuppressLint("SetTextI18n")
                @Override
                public void run() {
                    currentTag.setText(epcStr);
                    singnalStrength.setProgress(finalRssi);
                    playSound(finalRssi);
                }
            });
        } else {
            getActivity().runOnUiThread(new Runnable() {
                @Override
                public void run() {
                    currentTag.setText(null);
                    singnalStrength.setProgress(0);
                }
            });
        }
    }

    private long currentMinute, oldMinute;

    //Play Sound
    private void playSound(int val) {
        if (MyApp.ifOpenSound) {
            if (val > 30) {
                MyApp.getMyApp().playSound();
                oldMinute = System.currentTimeMillis();
            } else if (val > 20) {
                currentMinute = System.currentTimeMillis();
                if (currentMinute - oldMinute > 300) {
                    MyApp.getMyApp().playSound();
                    oldMinute = currentMinute;
                }
            } else if (val > 10) {
                currentMinute = System.currentTimeMillis();
                if (currentMinute - oldMinute > 600) {
                    MyApp.getMyApp().playSound();
                    oldMinute = currentMinute;
                }
            } else if (val > 0) {
                currentMinute = System.currentTimeMillis();
                if (currentMinute - oldMinute > 900) {
                    MyApp.getMyApp().playSound();
                    oldMinute = currentMinute;
                }
            }
        }
    }


}
